--[[
	Original Author: Imo 
	A simple addon that makes life tap post 1.12 scale to not kill yourself in PvP.
--]]


local ilt_SR = {0.38,0.68,0.8,0.8,0.8,0.8};
local ilt_LR = {30,75,140,220,310,424};


function ilt_OnLoad()
	-- Register Slash Commands
	SlashCmdList["ilt"] = ilt_slashCommand
	SLASH_ilt1 = "/IziLifeTap"
	SLASH_ilt2 = "/ilt"
	-- Register for events
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("UNIT_INVENTORY_CHANGED")
	this:RegisterEvent("LEARNED_SPELL_IN_TAB")
 	this:RegisterEvent("CHARACTER_POINTS_CHANGED")
	this:RegisterForClicks("LeftButtonUp")
	-- Checking for dependencie
	if not IsAddOnLoaded("BonusScanner") then
		UIErrorsFrame:AddMessage(ILT_ER_BS,1,1,0,1,UIERRORS_HOLD_TIME)
		if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("### Enable BonnusScanner in your addon setup window please ###") end
	end
end


function ilt_OnEvent()
	if ( event == "VARIABLES_LOADED" ) then
		DEFAULT_CHAT_FRAME:AddMessage("IziLifeTap " .. IZILIFETAP_VERSION .. " Loaded")
		-- check for first time
		if not iltDebug then iltDebug = false end
		if not iltLock then iltLock = false end
		if not iltVis then iltVis = true end
		if not iltRatio then iltRatio = 4 end
		if not iltMode then iltMode = "PvP" end
		if not iltMult then ILT_MUST_INIT_MULT=true end
		if not iltMaxRank then ILT_MUST_INIT_MAX_RANK=true end
		if not iltSpell then ILT_MUST_INIT_SPELL=true end
		-- init the frame
		ilt_UpdateFrame()
	elseif ( event == "UNIT_INVENTORY_CHANGED" and arg1 == "player" ) then
		if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("IziLifeTap has detected a change in your equipment") end
		ilt_SpellUpdate()
	elseif ( event == "LEARNED_SPELL_IN_TAB" ) then
		ilt_GetMaxRank()
	elseif ( event == "CHARACTER_POINTS_CHANGED" ) then
		ilt_GetMultiplier()
	end
end


function ilt_slashCommand (msg)
	if(strlen(msg) > 0) then
		if(string.find(msg, "debug")) then
			if iltDebug then iltDebug=false; DEFAULT_CHAT_FRAME:AddMessage("IziLifeTap Debug Mode off")
			else iltDebug=true; DEFAULT_CHAT_FRAME:AddMessage("IziLifeTap Debug Mode on") end
		elseif(string.find(msg, "ratio")) then
			_,_,iltRatio = string.find(msg, "ratio (%d+)")
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_RATIO1 ..iltRatio.. ILT_MSG_RATIO2)
		elseif(string.find(msg, "spell")) then
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_SPELL1)
			ilt_SpellUpdate();
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_SPELL2 .. iltSpell)
		elseif(string.find(msg, "hide")) then
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_HIDE)
			iltVis=false
			ilt_UpdateFrame()
		elseif(string.find(msg, "show")) then
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_SHOW)
			iltVis=true
			ilt_UpdateFrame()
		elseif(string.find(msg, "unlock")) then
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_UNLOCK)
			iltLock=false
		elseif(string.find(msg, "lock")) then
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_LOCK)
			iltLock=true
		elseif(string.find(msg, "pvp")) then
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_PVP)
			iltMode="PvP"
			ilt_UpdateFrame()
		elseif(string.find(msg, "pve")) then
			DEFAULT_CHAT_FRAME:AddMessage(ILT_MSG_PVE)
			iltMode="PvE"
			ilt_UpdateFrame()
		else
			iltAnnounce()
		end
	else
		iltAnnounce()
	end
end


function iltAnnounce()
	DEFAULT_CHAT_FRAME:AddMessage(ILT_USE)
	DEFAULT_CHAT_FRAME:AddMessage(ILT_USE_SPELL) 
	DEFAULT_CHAT_FRAME:AddMessage(ILT_USE_VIS)
	DEFAULT_CHAT_FRAME:AddMessage(ILT_USE_LOCK)
	DEFAULT_CHAT_FRAME:AddMessage(ILT_USE_MODE)
	DEFAULT_CHAT_FRAME:AddMessage(ILT_USE_RATIO1)
	DEFAULT_CHAT_FRAME:AddMessage(ILT_USE_RATIO2)
end

function ilt_AutoScale()
	-- check for 1st time
	if ILT_MUST_INIT_MULT then ilt_GetMultiplier(); ILT_MUST_INIT_MULT=false end
	if ILT_MUST_INIT_MAX_RANK then ilt_GetMaxRank(); ILT_MUST_INIT_MAX_RANK=false end
	if ILT_MUST_INIT_SPELL then ilt_SpellUpdate(); ILT_MUST_INIT_SPELL=false end

	-- normal routine
	if (iltMode == "PvP") then
		ilt_AutoScale_PvP()
		if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("PvP Mode :") end
	elseif (iltMode == "PvE") then
		ilt_AutoScale_PvE()
		if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("PvE Mode :") end
	else
		UIErrorsFrame:AddMessage(ILT_ER_IMPOSSIBLE,1,1,0,1,10)
	end	
end


function ilt_AutoScale_PvP()
	if IsAddOnLoaded("BonusScanner") then
		for i=iltMaxRank,1,-1 do
			if ( UnitHealth("player") > (iltSpell * ilt_SR[i] + ilt_LR[i] ) * iltRatio ) then
				if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("Casting Life Tap rank "..i) end
				CastSpellByName(ILT_SNAME .. "(" .. ILT_RANK .. " " .. i .. ")")
				break
			end
		end
	end
end


function ilt_AutoScale_PvE()
	if IsAddOnLoaded("BonusScanner") then
		for i=iltMaxRank,1,-1 do
			if( (UnitHealth("player") > ilt_LR[i] + ilt_SR[i] * iltSpell) and (UnitManaMax("player")-UnitMana("player") >= (ilt_LR[i]+ilt_SR[i]*iltSpell)*iltMult) ) then
				if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("Casting Life Tap rank "..i) end
				CastSpellByName(ILT_SNAME .. "(" .. ILT_RANK .. " " .. i .. ")")
				break
			end
		end
	end
end

function ilt_SpellUpdate()
	iltSpell = BonusScanner:GetBonus('DMG') + BonusScanner:GetBonus('SHADOWDMG');
	if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("New Shadow Spell Power = " .. iltSpell) end
end

function ilt_UpdateFrame ()
	if iltVis then
		iltText:SetText( "IziLifeTap\n\n   "..iltMode.."    " );
		if (iltMode=="PvP") then
			iltTextButton:SetBackdropBorderColor(0, 1, 0);
			iltTextButton:SetBackdropColor(0, 1, 0, 0.5);
		else
			iltTextButton:SetBackdropBorderColor(0, 0.5, 1);
			iltTextButton:SetBackdropColor(0, 0.5, 1, 0.5);
		end
		iltFrame:Show()
	else
		iltFrame:Hide()
	end
end


function ilt_OnDragStart()
	if not iltLock then
		if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("IziLifeTap Frame is moving") end
		iltFrame:StartMoving()
	end
end


function ilt_OnDragStop()
	if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("IziLifeTap Frame stops moving") end
	iltFrame:StopMovingOrSizing()
end


function ilt_OnClick()
	if iltLock then
		if iltMode=="PvP" then
			if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("IziLifeTap PvE Mode") end
			iltMode="PvE"
			ilt_UpdateFrame ()
		else
			if iltDebug then DEFAULT_CHAT_FRAME:AddMessage("IziLifeTap PvP Mode") end
			iltMode="PvP"
			ilt_UpdateFrame ()
		end
	end
end


function ilt_GetMultiplier()
	local name,_,_,_,rank,_ = GetTalentInfo(1,5)
	iltMult = 1

	if ilt_Debug then DEFAULT_CHAT_FRAME:AddMessage(name.." "..rank) end

	if (name == ILT_TALENT) then
		if rank == 1 then
			iltMult = 1.1
		elseif rank == 2 then
			iltMult = 1.2
		end
	else
		UIErrorsFrame:AddMessage(ILT_ER_TALENT,1,0,0,1,10)
	end
end


function ilt_GetMaxRank()
	iltMaxRank = 0
	local i = 1
	while true do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
		if not spellName then
			do break end
		end
		if spellName==ILT_SNAME then
			local _,_,r = string.find(spellRank, ILT_RANK.." (%d+)")
			if tonumber(r)>iltMaxRank then iltMaxRank=tonumber(r) end
		end
		i=i+1
	end
	if ilt_Debug then DEFAULT_CHAT_FRAME:AddMessage("Highest rank of Life Tap is " .. iltMaxRank) end

	if iltMaxRank==0 then
		UIErrorsFrame:AddMessage(ILT_ER_NW1,1,1,0,1,30)
		UIErrorsFrame:AddMessage(ILT_ER_NW2,1,0,0,1,30)
	end
end